package com.sf.web.dms.statistics.proxy;

package ..deTemp.1731161014638;

import com.sf.web.dms.common.ws.MsgProxyWebSocketService;
import com.sf.web.dms.common.ws.client.MsgProxyClient;
import com.sf.web.dms.statistics.bean.RtuOnlineParaVO;
import com.sf.web.dms.statistics.bean.ScadaEventBean;
import com.sf.web.dms.statistics.bean.StatisticsParaVO;
import com.sf.web.dms.statistics.proxy.Zone1AuthHandler;
import com.sf.web.dms.statistics.service.CustomizeService;
import com.sf.web.dms.statistics.service.RtuOnlineService;
import com.sf.web.dms.statistics.service.ScadaEventService;
import com.sf.web.dms.statistics.service.StatisIndexService;
import com.smartframework.core.dao.JdbcDao;
import com.smartframework.core.smart.SmartHelper;
import com.smartframework.web.core.Constants;
import com.smartframework.web.core.queryfilter.QueryFilter;
import com.smartframework.web.core.util.JsonUtil;
import com.smartframework.web.core.util.ParameterUtils;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;

public class Zone1QueryHandler extends Thread {
  public static Logger logger = Logger.getLogger(com.sf.web.dms.statistics.proxy.Zone1QueryHandler.class);
  
  private Zone1AuthHandler zone1AuthHandler = new Zone1AuthHandler();
  
  Map<String, Object> mParas = null;
  
  Integer mRequestId = null;
  
  public Zone1QueryHandler(Integer iRequestId, Map<String, Object> iParas) {
    this.mRequestId = iRequestId;
    this.mParas = iParas;
  }
  
  public void run() {
    logger.info("收到跨区查询指标请求，开始查询 KPI");
    String resultValue = queryKPI(this.mParas);
    Map<String, Object> json = new HashMap<>();
    json.put("requestId", this.mRequestId);
    json.put("resultValue", resultValue);
    logger.info("KPI查询完成，准备使用MsgProxyClient发送");
    MsgProxyClient client = null;
    try {
      client = new MsgProxyClient("123", MsgProxyWebSocketService.getAvailableConnect(null));
      client.start();
      client.switchCtx("real");
      client.subTopics(Arrays.asList(new String[] { "MT_RESPONSE_STATISTICS_RESULT" }));
      logger.info(client + "===== switchCtx =====");
      client.sendMsg("MT_RESPONSE_STATISTICS_RESULT", json, 0, 0, 0, 0);
      logger.info("Send MT_RESPONSE_STATISTICS_RESULT msg. requestId=" + this.mRequestId.toString() + ", resultValue=" + resultValue.toString());
    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      if (client != null)
        try {
          client.close();
        } catch (Exception e) {
          logger.info("Close MsgProxyClient " + client + " Exception.", e);
        }  
    } 
  }
  
  public void queryKPI() {
    String retStr = queryKPI(this.mParas);
  }
  
  static void PrintMap(String title, Map<String, Object> map) {
    logger.info("------- " + title + " -------");
    for (Map.Entry<String, Object> entry : map.entrySet())
      logger.info("queryKPI: Key = " + (String)entry.getKey() + ", Value = " + entry.getValue()); 
  }
  
  public String queryKPI(Map<String, Object> paras) {
    PrintMap("Request", paras);
    String kpiType = null;
    String timeRange = null;
    String userName = null;
    Long rtuId = null;
    Long stationId = null;
    Long feederId = null;
    String remoteIp = null;
    Integer orgLevel = null;
    Integer orgId = null;
    List<Integer> commType = new ArrayList<>();
    List<Integer> manuFac = new ArrayList<>();
    List<Integer> isTransmit = new ArrayList<>();
    List<Integer> rtuType = new ArrayList<>();
    Integer pageSize = Integer.valueOf(-1);
    Integer pageIndex = Integer.valueOf(-1);
    String result = "1";
    List<Map<String, Object>> listData = new ArrayList<>();
    if (ParameterUtils.isEmptyOrNull(paras.get("kpi_type"))) {
      logger.error("kpi_type is null or empty");
      return "NaN";
    } 
    kpiType = paras.get("kpi_type").toString();
    if (!ParameterUtils.isEmptyOrNull(paras.get("time_range")))
      timeRange = paras.get("time_range").toString(); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("user_name")))
      userName = paras.get("user_name").toString(); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("rtu_id")))
      rtuId = Long.valueOf(Long.parseLong(paras.get("rtu_id").toString())); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("remote_ip")))
      remoteIp = paras.get("remote_ip").toString(); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("station_id")))
      stationId = Long.valueOf(Long.parseLong(paras.get("station_id").toString())); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("feeder_id")))
      feederId = Long.valueOf(Long.parseLong(paras.get("feeder_id").toString())); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("comm_type")))
      commType = (List<Integer>)paras.get("comm_type"); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("manu_fac")))
      manuFac = (List<Integer>)paras.get("manu_fac"); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("is_transmit")))
      isTransmit = (List<Integer>)paras.get("is_transmit"); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("rtu_type")))
      rtuType = (List<Integer>)paras.get("rtu_type"); 
    if (!ParameterUtils.isEmptyOrNull(paras.get("page_size")));
    if (!ParameterUtils.isEmptyOrNull(paras.get("page_index")));
    if (!ParameterUtils.isEmptyOrNull(paras.get("area_resp"))) {
      Integer region = Integer.valueOf(Integer.parseInt(paras.get("area_resp").toString()));
      logger.info("regionId:" + region);
      this.zone1AuthHandler.regionId = Integer.valueOf(Integer.parseInt(paras.get("area_resp").toString()));
    } 
    logger.info("一三区传的RegionId:：" + this.zone1AuthHandler.regionId);
    logger.info("根据一三区上传用户名获取组织机构信息，当前用户名: " + userName);
    JdbcDao jdbcDao = (JdbcDao)SmartHelper.getBean(JdbcDao.class);
    if (!ParameterUtils.isEmptyOrNull(paras.get("org_id")) && !paras.get("org_id").equals("-1")) {
      orgId = Integer.valueOf(Integer.parseInt(paras.get("org_id").toString()));
      logger.info("org_id:" + orgId);
      String sqlOrgLevel = "select org_level as level from sys_organization where id=" + orgId;
      Map<String, Object> orgObj = jdbcDao.queryForSingle(sqlOrgLevel);
      if (orgObj != null)
        orgLevel = Integer.valueOf(Integer.parseInt(String.valueOf(orgObj.get("level")))); 
    } else {
      StringBuilder sb = (new StringBuilder("select so.id,so.org_level as level from sys_organization so left join sys_org_user_link o on o.org_id = so.id left join sys_web_user s on s.id = o.user_id where s.user_name = '")).append(userName).append("'");
      List<Map<String, Object>> results = jdbcDao.queryForList(sb.toString());
      logger.info("获取缺省用户组织机构信息:" + sb.toString());
      if (results.size() > 0) {
        orgId = Integer.valueOf(Integer.parseInt(String.valueOf(((Map)results.get(0)).get("id"))));
        orgLevel = Integer.valueOf(Integer.parseInt(String.valueOf(((Map)results.get(0)).get("level"))));
      } 
      logger.info("orgId: " + orgId + ",orgLevel: " + orgLevel);
    } 
    logger.info("orgId: " + orgId + ",orgLevel: " + orgLevel);
    logger.info("上传的时间范围为: " + timeRange);
    if (kpiType.equals("RTU_Sys_Org")) {
      if (userName == null) {
        result = "传入的用户名为空";
      } else {
        StringBuilder querySysOrgSql = (new StringBuilder("select so.id,so.org_level as level from sys_organization so left join sys_org_user_link o on o.org_id = so.id left join sys_web_user s on s.id = o.user_id where s.user_name = '")).append(userName).append("'");
        List<Map<String, Object>> resultSysOrg = jdbcDao.queryForList(querySysOrgSql.toString());
        if (resultSysOrg.size() > 0) {
          Integer rtuSysOrgId = Integer.valueOf(Integer.parseInt(String.valueOf(((Map)resultSysOrg.get(0)).get("id"))));
          StringBuilder querySysOrgSqlAll = new StringBuilder("select so.id as org_id,so.org_level,so.name as org_name from sys_organization so where id=");
          querySysOrgSqlAll.append(rtuSysOrgId).append(" ").append("union").append(" ");
          querySysOrgSqlAll.append("select so.id as org_id,so.org_level,so.name as org_name from sys_organization so where pid=").append(rtuSysOrgId);
          List<Map<String, Object>> resultSysOrgAll = jdbcDao.queryForList(querySysOrgSqlAll.toString());
          result = JsonUtil.getJsonByObject(resultSysOrgAll);
        } 
      } 
    } else if (kpiType.equalsIgnoreCase("YK_SuccessRate")) {
      this.zone1AuthHandler.condKeyString = "e.feeder_id";
      ScadaEventBean scadaEventBean = new ScadaEventBean();
      if (!ParameterUtils.isEmptyOrNull(timeRange)) {
        logger.info("使用一三区传递的时间范围:" + timeRange);
        scadaEventBean.setTimeRange(timeRange);
      } else {
        logger.info("使用四区传递的时间范围");
        scadaEventBean.setTimeRange(CustomizeService.queryDeafultTimeRange());
      } 
      scadaEventBean.setRtuType((ArrayList)CustomizeService.queryRtuType());
      scadaEventBean.setIsTransmit(CustomizeService.queryRtuTransmit());
      QueryFilter queryFilter = new QueryFilter();
      try {
        queryFilter = scadaEventBean.getQueryFilter(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      queryFilter.setPageInfo(pageSize, pageIndex);
      Map<String, Object> records = ((StatisIndexService)SmartHelper.getBean(StatisIndexService.class)).queryRemoteControl(queryFilter, orgLevel, orgId, this.zone1AuthHandler);
      PrintMap("Response", records);
      if (records != null && records.get("total") != null && records.get("success") != null) {
        Double total = Double.valueOf(Double.parseDouble(records.get("total").toString()));
        Double success = Double.valueOf(Double.parseDouble(records.get("success").toString()));
        DecimalFormat df = new DecimalFormat("#0.0000");
        result = (total.doubleValue() > 0.0D) ? df.format(success.doubleValue() / total.doubleValue()).toString() : "1";
      } 
    } else if (kpiType.equalsIgnoreCase("YX_AccuracyRate")) {
      this.zone1AuthHandler.condKeyString = "e.feeder_id";
      ScadaEventBean scadaEventBean = new ScadaEventBean();
      scadaEventBean.setRtuType((ArrayList)CustomizeService.queryRtuType());
      scadaEventBean.setIsTransmit(CustomizeService.queryRtuTransmit());
      if (!ParameterUtils.isEmptyOrNull(timeRange)) {
        logger.info("使用一三区传递的时间范围");
        scadaEventBean.setTimeRange(timeRange);
      } else {
        scadaEventBean.setTimeRange(CustomizeService.queryDeafultTimeRange());
      } 
      QueryFilter queryFilter = new QueryFilter();
      try {
        queryFilter = scadaEventBean.getQueryFilter(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      queryFilter.setPageInfo(pageSize, pageIndex);
      Map<String, Object> records = ((StatisIndexService)SmartHelper.getBean(StatisIndexService.class)).querySignalAccuracy(queryFilter, orgLevel, orgId, this.zone1AuthHandler);
      PrintMap("Response", records);
      if (records != null && records.get("total") != null && records.get("success") != null) {
        Double total = Double.valueOf(Double.parseDouble(records.get("total").toString()));
        Double success = Double.valueOf(Double.parseDouble(records.get("success").toString()));
        DecimalFormat df = new DecimalFormat("#0.0000");
        result = (total.doubleValue() > 0.0D) ? df.format(success.doubleValue() / total.doubleValue()) : "1";
      } 
    } else if (kpiType.equalsIgnoreCase("RTU_CoverRate")) {
      this.zone1AuthHandler.condKeyString = "_all.id";
      Map<String, Object> records = ((StatisIndexService)SmartHelper.getBean(StatisIndexService.class)).queryRtuCover(null, null, orgLevel, orgId, this.zone1AuthHandler);
      PrintMap("Response RTU_CoverRate : ", records);
      if (records != null && records.get("total") != null && records.get("success") != null) {
        Double total = Double.valueOf(Double.parseDouble(records.get("total").toString()));
        Double success = Double.valueOf(Double.parseDouble(records.get("success").toString()));
        DecimalFormat df = new DecimalFormat("#0.0000");
        result = (total.doubleValue() > 0.0D) ? df.format(success.doubleValue() / total.doubleValue()) : "1";
      } 
    } else if (kpiType.equalsIgnoreCase("RTU_RtOnlineRate")) {
      this.zone1AuthHandler.condKeyString = "e.fid";
      StatisticsParaVO statisticsParaVO = new StatisticsParaVO();
      statisticsParaVO.setCommType(commType);
      statisticsParaVO.setType(rtuType);
      statisticsParaVO.setManuFac(manuFac);
      statisticsParaVO.setIsTransmit(isTransmit);
      QueryFilter queryFilter = new QueryFilter();
      try {
        queryFilter = statisticsParaVO.getQueryFilter(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      queryFilter.setPageInfo(pageSize, pageIndex);
      Map<String, Object> records = ((StatisIndexService)SmartHelper.getBean(StatisIndexService.class)).queryRealtimeRtuOnline(queryFilter, orgLevel, orgId, this.zone1AuthHandler);
      PrintMap("Response RTU_RtOnlineRate : ", records);
      if (records != null && records.get("total") != null && records.get("online") != null) {
        Double total = Double.valueOf(Double.parseDouble(records.get("total").toString()));
        Double success = Double.valueOf(Double.parseDouble(records.get("online").toString()));
        DecimalFormat df = new DecimalFormat("#0.0000");
        result = (total.doubleValue() > 0.0D) ? df.format(success.doubleValue() / total.doubleValue()) : "1";
      } 
    } else if (kpiType.equalsIgnoreCase("RTU_HsOnlineRate")) {
      RtuOnlineParaVO rtuOnlineParaVO = new RtuOnlineParaVO();
      rtuOnlineParaVO.setId(null);
      if (Constants.integerConfigIsEnabled("dms.unload.home.data")) {
        rtuOnlineParaVO.setStationId(stationId);
        rtuOnlineParaVO.setFeederId(feederId);
        rtuOnlineParaVO.setCommType(commType);
        rtuOnlineParaVO.setType(rtuType);
        rtuOnlineParaVO.setManuFac(manuFac);
        rtuOnlineParaVO.setIsTransmit(isTransmit);
      } else {
        rtuOnlineParaVO.setIsTransmit(CustomizeService.queryRtuTransmit());
        rtuOnlineParaVO.setType(CustomizeService.queryRtuType());
      } 
      if (!ParameterUtils.isEmptyOrNull(timeRange)) {
        logger.info("使用一三区传递的时间范围");
        rtuOnlineParaVO.setTimeRange(timeRange);
      } else {
        rtuOnlineParaVO.setTimeRange(CustomizeService.queryDeafultTimeRange());
      } 
      QueryFilter queryFilter0 = new QueryFilter(), queryFilter1 = new QueryFilter(), queryFilter2 = new QueryFilter();
      try {
        queryFilter0 = rtuOnlineParaVO.getQueryFilter0(null, null);
        queryFilter1 = rtuOnlineParaVO.getQueryFilter1(null, null);
        queryFilter2 = rtuOnlineParaVO.getQueryFilter2(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      queryFilter0.setPageInfo(pageSize, pageIndex);
      queryFilter1.setPageInfo(pageSize, pageIndex);
      queryFilter2.setPageInfo(pageSize, pageIndex);
      Date endTime = new Date();
      Map<String, Object> records = ((StatisIndexService)SmartHelper.getBean(StatisIndexService.class)).queryRtuOnline(queryFilter0, queryFilter1, queryFilter2, endTime, orgLevel, orgId, this.zone1AuthHandler, Integer.valueOf(0));
      PrintMap("Response RTU_HsOnlineRate : ", records);
      if (records != null && records.get("total") != null && records.get("online") != null) {
        Double total = Double.valueOf(Double.parseDouble(records.get("total").toString()));
        Double success = Double.valueOf(Double.parseDouble(records.get("online").toString()));
        DecimalFormat df = new DecimalFormat("#0.0000");
        result = (total.doubleValue() > 0.0D) ? df.format(success.doubleValue() / total.doubleValue()) : "1";
      } 
    } else if (kpiType.equalsIgnoreCase("YK_SuccessRate_Detial")) {
      this.zone1AuthHandler.condKeyString = "e.feeder_id";
      ScadaEventBean scadaEventBean = new ScadaEventBean();
      scadaEventBean.setTimeRange(timeRange);
      QueryFilter queryFilter = new QueryFilter();
      try {
        queryFilter = scadaEventBean.getQueryFilter(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      queryFilter.setPageInfo(pageSize, pageIndex);
      listData = ((ScadaEventService)SmartHelper.getBean(ScadaEventService.class)).queryControlRecordsZ1(queryFilter, orgLevel, orgId, this.zone1AuthHandler);
      for (int i = 0; i < listData.size(); i++)
        PrintMap("Response YK_SuccessRate_Detial : ", listData.get(i)); 
      result = JsonUtil.getJsonByObject(listData);
    } else if (kpiType.equalsIgnoreCase("YX_AccuracyRate_Detial")) {
      this.zone1AuthHandler.condKeyString = "e.feeder_id";
      ScadaEventBean scadaEventBean = new ScadaEventBean();
      scadaEventBean.setTimeRange(timeRange);
      QueryFilter queryFilter = new QueryFilter();
      try {
        queryFilter = scadaEventBean.getQueryFilter(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      queryFilter.setPageInfo(pageSize, pageIndex);
      listData = ((ScadaEventService)SmartHelper.getBean(ScadaEventService.class)).querySignalRecordsZ1(queryFilter, orgLevel, orgId, this.zone1AuthHandler);
      for (int i = 0; i < listData.size(); i++)
        PrintMap("Response YX_AccuracyRate_Detial : ", listData.get(i)); 
      result = JsonUtil.getJsonByObject(listData);
    } else if (kpiType.equalsIgnoreCase("RTU_HsOnlineRate_Detial")) {
      RtuOnlineParaVO rtuOnlineParaVO = new RtuOnlineParaVO();
      rtuOnlineParaVO.setStationId(stationId);
      rtuOnlineParaVO.setFeederId(feederId);
      rtuOnlineParaVO.setOrgId(orgId);
      rtuOnlineParaVO.setRemoteIp(remoteIp);
      rtuOnlineParaVO.setTimeRange(timeRange);
      rtuOnlineParaVO.setCommType(commType);
      rtuOnlineParaVO.setManuFac(manuFac);
      rtuOnlineParaVO.setIsTransmit(isTransmit);
      rtuOnlineParaVO.setType(rtuType);
      QueryFilter queryFilter0 = new QueryFilter(), queryFilter1 = new QueryFilter(), queryFilter2 = new QueryFilter();
      try {
        queryFilter0 = rtuOnlineParaVO.getQueryFilter0(null, null);
        queryFilter1 = rtuOnlineParaVO.getQueryFilter1(null, null);
        queryFilter2 = rtuOnlineParaVO.getQueryFilter2(null, null);
      } catch (Exception e) {
        e.printStackTrace();
      } 
      Date endTime = new Date();
      if (rtuOnlineParaVO.getTimeRange() != null && (rtuOnlineParaVO.getTimeRange()).length == 2 && rtuOnlineParaVO.getTimeRange()[1] != null)
        endTime = rtuOnlineParaVO.getTimeRange()[1]; 
      queryFilter0.setPageInfo(pageSize, pageIndex);
      queryFilter1.setPageInfo(pageSize, pageIndex);
      queryFilter2.setPageInfo(pageSize, pageIndex);
      listData = ((RtuOnlineService)SmartHelper.getBean(RtuOnlineService.class)).queryRecordsZ1(queryFilter0, queryFilter1, queryFilter2, endTime, orgLevel, orgId, this.zone1AuthHandler);
      for (int i = 0; i < listData.size(); i++)
        PrintMap("Response RTU_HsOnlineRate_Detial : ", listData.get(i)); 
      result = JsonUtil.getJsonByObject(listData);
    } else {
      logger.warn("Invalid kpiType: " + kpiType);
    } 
    return result;
  }
}
